#!/usr/bin/python

from mod_utils          import Choice
from xml.dom.minidom    import parse
from xml.dom.minidom    import parseString

import xml.dom.minidom
import time
import sys

class ecu_mnemolocation:
  name  = ""
  startByte = 0
  startBit  = 0
  rOffset   = 0
  
  def __init__(self, ml ):
    self.name = ml.getAttribute("name")
    self.startByte = ml.getAttribute("startByte")
    self.startBit  = ml.getAttribute("startBit")
    self.rOffset   = ml.getAttribute("rOffset")

class ecu_service_response:
  val   = ""
  status = 0
  mnemolocations = {}
  
  def __init__(self, sr ):
    self.val = sr.getAttribute("val")
    self.status = sr.getAttribute("status")
    
    self.mnemolocations = {}
    #print "test1_mnemoloc: ",len(self.mnemolocations)
    #print sr.toprettyxml()

    MnemoLocations = sr.getElementsByTagName("MnemoLocation")
    if MnemoLocations:
      for ml in MnemoLocations:
        mnemoloc = ecu_mnemolocation( ml )
        self.mnemolocations[mnemoloc.name] = mnemoloc

def rspStrip( rsp, req ):
  rsp = rsp.replace( req, '' )
  rsp = rsp.replace( '>', '' )
  rsp = rsp.replace( ' ', '' )
  rsp = rsp.replace( '\t', '' )
  return rsp

def executeService( service, elm, status = [], param = "", cache = False ):
  #print "Start of execution service: ", service.id
  
  #tb = time.time()   #start time 
  #tc = tb

  commandToSend = service.startReq
  
  if len(service.params)==1:
    commandToSend += param
  
  try:
    localDelay = int(service.delay)
  except ValueError:
    localDelay = 0
    
  if len(service.startNextDelay)>1:
    localDelay = service.startNextDelay
  
  rsp = elm.request( commandToSend, '', cache, localDelay )
  rsp = rspStrip( rsp, commandToSend )
  
  #print "Delay:",localDelay,
  #print "startReq	", service.startReq
  #print "repeatReq	", service.repeatReq
  #print "simpleRsp	", service.simpleRsp
  #print "startNextDelay	", service.startNextDelay
  #print "repeatNextDelay	", service.repeatNextDelay
  #print "responces	", service.responces
  #print "responcesRepeat	", service.responcesRepeat
  #print "startRepeatInProgres	", service.startRepeatInProgres
  #print "repeatRepeatInProgres 	", service.repeatRepeatInProgres 
  #print "params ", service.params

  #te = time.time()   #end time 
  
  #check for simple responce
  if rsp.startswith( service.simpleRsp ):
    return rsp
  
  #if rsp in service.responces.keys():
  for rspk in service.responces.keys():
    if rsp.startswith( rspk ):
      #print '\r',' '*80,"\rStatus:",status[service.responces[rsp].status].encode(sys.stdout.encoding, errors='replace'),
      sys.stdout.flush()
      break
    
  #if rsp not in service.startRepeatInProgres.keys():
  flag = True;
  for rspk in service.startRepeatInProgres.keys():
    if rsp.startswith( rspk ):
      flag = False;
      break
  if flag:
    #print
    return rsp
    
  #Repeat
  commandToSend = service.repeatReq
  localDelay = service.delay
  if len(service.repeatNextDelay)>1:
    localDelay = service.repeatNextDelay
  count = 0
  while count<100: # just for not to step into infinite loop
    count += 1
    rsp = elm.request( commandToSend, '', cache, localDelay )
    rsp = rspStrip( rsp, commandToSend )
  
    #if rsp in service.responces.keys():
    for rspk in service.responces.keys():
      if rsp.startswith( rspk ):
        #print '\r',' '*80,"\rStatus:",status[service.responcesRepeat[rsp].status].encode(sys.stdout.encoding, errors='replace'), count,
        sys.stdout.flush()
        break
    
    #if rsp not in service.repeatRepeatInProgres.keys():
    flag = True;
    for rspk in service.repeatRepeatInProgres.keys():
      if rsp.startswith( rspk ):
        flag = False;
        break
    if flag:
      #print
      return rsp
  
  print "\nSomething went wrong. Counter reached maximum value.\n"
  return ""  


class ecu_service:

  id        = ""
  delay     = ""
  mode      = ""
  startReq  = ""
  repeatReq = ""
  simpleRsp = ""
  startNextDelay   = 0
  repeatNextDelay  = 0
  responces             = {}
  responcesRepeat       = {}
  startRepeatInProgres  = {}
  repeatRepeatInProgres = {}  
  params                = []
    
  def __init__(self, sv ):
    self.id = sv.getAttribute("serviceID")
    self.delay = sv.getAttribute("delay")
    self.mode  = sv.getAttribute("mode")
    
    self.responces             = {}
    self.responcesRepeat       = {}
    self.startRepeatInProgres  = {}
    self.repeatRepeatInProgres = {}  
    self.params                = []
    
    Start = sv.getElementsByTagName("Start")
    if Start:
      for st in Start:
        Request = st.getElementsByTagName("Request").item(0)
        if Request:
          #print Request.toprettyxml()
          self.startReq = Request.getAttribute("val")
          self.startNextDelay = Request.getAttribute("nextDelay")
          
          #self.params    = []
          Params = Request.getElementsByTagName("Params").item(0)
          if Params:
            Param = Params.getElementsByTagName("Param")
            if Param:
              for pr in Param:
                parm_dic = {}
                parm_dic["rank"] = pr.getAttribute("rank")
                parm_dic["type"] = pr.getAttribute("type")
                parm_dic["pos"] = pr.getAttribute("pos")
                if pr.hasAttribute("size"):
                  parm_dic["size"] = pr.getAttribute("size")
                else:
                  parm_dic["size"] = ''
                self.params.append( parm_dic )
        
        self.simpleRsp = ""
        Simple = st.getElementsByTagName("Simple").item(0)
        if Simple:
          resp = ecu_service_response( Simple )
          self.responces[resp.val] = resp
          self.simpleRsp = resp.val  
           
        RepeatInProgress = st.getElementsByTagName("RepeatInProgress").item(0)
        if RepeatInProgress:
          resp = ecu_service_response( RepeatInProgress )
          self.responces[resp.val] = resp 
          self.startRepeatInProgres[resp.val] = resp 
  
        Resp = st.getElementsByTagName("Resp")
        if Resp:
          for rsp in Resp:
            resp = ecu_service_response( rsp )
            self.responces[resp.val] = resp 
 
    Repeat = sv.getElementsByTagName("Repeat")
    if Repeat:
      for rep in Repeat:
        Request = rep.getElementsByTagName("Request").item(0)
        if Request:
          self.repeatReq = Request.getAttribute("val")
          self.repeatNextDelay = Request.getAttribute("nextDelay")
        
        Simple = rep.getElementsByTagName("Simple").item(0)
        if Simple:
          resp = ecu_service_response( Simple )
          self.responces[resp.val] = resp 
           
        RepeatInProgress = rep.getElementsByTagName("RepeatInProgress").item(0)
        if RepeatInProgress:
          resp = ecu_service_response( RepeatInProgress )
          self.responcesRepeat[resp.val] = resp 
          self.repeatRepeatInProgres[resp.val] = resp 
  
        Resp = rep.getElementsByTagName("Resp")
        if Resp:
          for rsp in Resp:
            resp = ecu_service_response( rsp )
            self.responcesRepeat[resp.val] = resp 
    
class ecu_services:
 
  def __init__(self, service_list, mdoc, opt, tran ):
    
    for k in opt.keys():
      if "Service" in k:
        xmlstr = opt[k]
        odom = xml.dom.minidom.parseString( xmlstr.encode( "utf-8" ) )
        odoc = odom.documentElement

        service = ecu_service( odoc )
        service_list[service.id] = service
       